package com.bbva.pzic.claims.canonic;

import com.bbva.pzic.claims.facade.v0.dto.*;
import com.bbva.pzic.routine.commons.utils.CustomCalendarAdapter;

import javax.xml.bind.annotation.*;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import java.io.Serializable;
import java.util.Calendar;
import java.util.List;

/**
 * @author Entelgy
 */
@XmlRootElement(name = "productClaim", namespace = "urn:com:bbva:pzic:claims:canonic")
@XmlType(name = "productClaim", namespace = "urn:com:bbva:pzic:claims:canonic")
@XmlAccessorType(XmlAccessType.FIELD)
public class ProductClaim implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * Unique identifier of the claim.
     */
    private String id;

    private String number;

    private ProductType personType;

    private Company company;
    /**
     * Indicates if the petitioner is an under age. It is mandatory if the petitioner is not a business.
     */
    private Boolean isUnderage;
    /**
     * Type of claim made by a person or business.
     */
    private ClaimType claimType;
    /**
     * Product identifier associated to the claim.
     */
    private Product product;

    /**
     * Reason associated with the product, for which the petition or claim is made.
     */
    private ReasonClaim reason;
    /**
     * Resolution of the claim analysis.
     */
    private Resolution resolution;
    /**
     * Required for product claims. in claims generated by a company must indicate the representative indicating the type of petitioner AUTHORIZED.
     */
    private List<Petitioners> petitioners;
    /**
     * It’s the identifier of the product contract.  DISCLAIMER: In case this field is not informed number is required.
     */
    private Contract contract;
    /**
     * Claim amount by the petitioner.
     */
    private Amount claimAmount;

    /**
     * Bank where the issue, related to the claim, is originated.
     */
    private Bank bank;
    /**
     * It’s the channel in which the petitioner submits the claim.
     */
    private Channel channel;
    /**
     * Geographical location from where the claim is registered. This code represents the three levels of the territorial subdivision in Perú.
     */
    private Geolocation geolocation;
    /**
     * Delivery of the submitted claim document to the petitioner.
     */
    private Delivery delivery;
    /**
     * Petition asked for the person who makes the claim.
     */
    private Petition petition;
    /**
     * Claim priority.
     */
    private Priority priority;
    /**
     * String based on ISO-8601 for specifying the claim enrollment date.
     */
    @XmlJavaTypeAdapter(CustomCalendarAdapter.class)
    @XmlSchemaType(name="dateTime")
    private Calendar enrollmentDate;
    /**
     * Claim that was previously registered in order to request the same petition that the current claim and associated to the same product.
     */
    private PredecessorClaim predecessorClaim;
    /**
     * It indicates if the person accepts the online refund.
     */
    private Boolean isOnlineRefundFlow;
    /**
     * External code that represents a previous online attention before to register the claim.
     */
    private String previousAttentionCode;
    /**
     * Additional claims related to the principal claim. It applies when the principal claim is multiple.
     */
    private List<AdditionalClaims> additionalClaims;
    /**
     * ATM where the issue, related to the claim, was held.
     */
    private Atm atm;
    /**
     * String based on ISO-8601 for specifying the date when the incident occurred to the customer.
     */
    @XmlJavaTypeAdapter(CustomCalendarAdapter.class)
    @XmlSchemaType(name="dateTime")
    private Calendar issueDate;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getNumber() {
        return number;
    }

    public void setNumber(String number) {
        this.number = number;
    }

    public ProductType getPersonType() {
        return personType;
    }

    public void setPersonType(ProductType personType) {
        this.personType = personType;
    }

    public Company getCompany() {
        return company;
    }

    public void setCompany(Company company) {
        this.company = company;
    }

    public Boolean getIsUnderage() {
        return isUnderage;
    }

    public void setIsUnderage(Boolean isUnderage) {
        this.isUnderage = isUnderage;
    }

    public ClaimType getClaimType() {
        return claimType;
    }

    public void setClaimType(ClaimType claimType) {
        this.claimType = claimType;
    }

    public Product getProduct() {
        return product;
    }

    public void setProduct(Product product) {
        this.product = product;
    }

    public ReasonClaim getReason() {
        return reason;
    }

    public void setReason(ReasonClaim reason) {
        this.reason = reason;
    }

    public Resolution getResolution() {
        return resolution;
    }

    public void setResolution(Resolution resolution) {
        this.resolution = resolution;
    }

    public List<Petitioners> getPetitioners() {
        return petitioners;
    }

    public void setPetitioners(List<Petitioners> petitioners) {
        this.petitioners = petitioners;
    }

    public Contract getContract() {
        return contract;
    }

    public void setContract(Contract contract) {
        this.contract = contract;
    }

    public Amount getClaimAmount() {
        return claimAmount;
    }

    public void setClaimAmount(Amount claimAmount) {
        this.claimAmount = claimAmount;
    }


    public Bank getBank() {
        return bank;
    }

    public void setBank(Bank bank) {
        this.bank = bank;
    }

    public Channel getChannel() {
        return channel;
    }

    public void setChannel(Channel channel) {
        this.channel = channel;
    }

    public Geolocation getGeolocation() {
        return geolocation;
    }

    public void setGeolocation(Geolocation geolocation) {
        this.geolocation = geolocation;
    }

    public Delivery getDelivery() {
        return delivery;
    }

    public void setDelivery(Delivery delivery) {
        this.delivery = delivery;
    }

    public Petition getPetition() {
        return petition;
    }

    public void setPetition(Petition petition) {
        this.petition = petition;
    }

    public Priority getPriority() {
        return priority;
    }

    public void setPriority(Priority priority) {
        this.priority = priority;
    }

    public Calendar getEnrollmentDate() {
        return enrollmentDate;
    }

    public void setEnrollmentDate(Calendar enrollmentDate) {
        this.enrollmentDate = enrollmentDate;
    }

    public PredecessorClaim getPredecessorClaim() {
        return predecessorClaim;
    }

    public void setPredecessorClaim(PredecessorClaim predecessorClaim) {
        this.predecessorClaim = predecessorClaim;
    }

    public Boolean getOnlineRefundFlow() {
        return isOnlineRefundFlow;
    }

    public void setOnlineRefundFlow(Boolean onlineRefundFlow) {
        isOnlineRefundFlow = onlineRefundFlow;
    }

    public String getPreviousAttentionCode() {
        return previousAttentionCode;
    }

    public void setPreviousAttentionCode(String previousAttentionCode) {
        this.previousAttentionCode = previousAttentionCode;
    }

    public List<AdditionalClaims> getAdditionalClaims() {
        return additionalClaims;
    }

    public void setAdditionalClaims(List<AdditionalClaims> additionalClaims) {
        this.additionalClaims = additionalClaims;
    }

    public Atm getAtm() {
        return atm;
    }

    public void setAtm(Atm atm) {
        this.atm = atm;
    }

    public Calendar getIssueDate() {
        return issueDate;
    }

    public void setIssueDate(Calendar issueDate) {
        this.issueDate = issueDate;
    }
}